
;;; ck-macros
;;; Composable Scheme macros based on the CK abstract machine.
;;; Version 0.3.1 (2024-01-27)
;;;
;;; All source code (including contributions) is released by its
;;; authors to the public domain. For more information, please refer
;;; to <http://unlicense.org>

(module ck-macros *
  (import scheme)
  (cond-expand
    (chicken-4
     (import chicken))
    (chicken-5
     (import (chicken base)
             (chicken syntax))))

  (include "lib/portable.scm")

  (begin-for-syntax
   (cond-expand
     (chicken-4 (import chicken))
     (else (begin)))
   (include "lib/ck-wrapper.scm")) ; Import into syntax env, for macro use

  (include "lib/ck-wrapper.scm")   ; Import into runtime env, for exporting

  (include "lib/wrappers-r5rs.scm"))
